config/routes.rb
Rails.application.routes.draw do
  resources :measurements

  resources :quantities, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :reparent }
  end

  resources :units, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :rebase }
  end

  namespace :default do
    resources :units, only: [:index, :destroy] do
      member { post :import, :export }
      #collection { post :import_all }
    end
  end

  devise_for :users, path: '', path_names: {registration: 'profile'},
    controllers: {registrations: :registrations}
  resources :users, only: [:index, :show, :update] do
    member { get :disguise }
    collection { get :revert }
  end

  unauthenticated do
    as :user do
      root to: redirect('/sign_in')
    end
  end
  root to: redirect('/units'), as: :user_root

  direct(:source_code) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me' }
  direct(:issue_tracker) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me/issues' }
end

app/controllers/measurements_controller.rb
class MeasurementsController < ApplicationController
  before_action :find_quantity, only: [:new]

  def index
    @quantities = current_user.quantities.ordered
  end

  def new
    prev_quantity_ids = params[:readouts]&.map { |r| r[:quantity_id] } || []
    @prev_quantities = current_user.quantities.find(prev_quantity_ids)

    quantities =
      case params[:scope]
      when 'children'
        @quantity.subquantities
      when 'subtree'
        @quantity.progenies
      else
        [@quantity]
      end
    quantities -= @prev_quantities
    @readouts = current_user.readouts.build(quantities.map { |q| {quantity: q} })

    all_quantities = @prev_qantities + quantities
    @closest_ancestor = current_user.quantities
      .common_ancestors(all_quantities.map(&:parent_id)).first
    all_quantites << @closest_ancestor if @closest_ancestor
    current_user.quantities.full_names!(all_quantities)

    @units = current_user.units.ordered
  end

  def create
  end

  def destroy
  end

  private

  def find_quantity
    @quantity = current_user.quantities.find_by!(id: params[:id])
  end
end

app/helpers/measurements_helper.rb
module MeasurementsHelper
end

app/views/measurements/_form.html.erb
<% @readouts.each do |readout| %>
  <%= tabular_fields_for 'readouts[]', readout do |form| %>
    <% row = dom_id(form.object.quantity, :new, :readout) %>
    <%- tag.tr id: row, onkeydown: 'processKey(event)' do %>
      <td>
        <%= form.object.quantity.full_name.delete_prefix(@closest_ancestor.full_name) %>
        <%= form.hidden_field :quantity_id %>
      </td>
      <td>
        <%= form.number_field :value, required: true, autofocus: true,
          size: 10 %>
      </td>
      <td>
        <%= form.select :unit_id, options_from_collection_for_select(
          @units, :id, ->(u){ sanitize('&emsp;'*(u.base_id ? 1 : 0) + u.symbol) }
        ) %>
      </td>

      <td class="actions">
        <%= image_link_to t(:delete), 'delete-outline', quantities_path,
          class: 'dangerous',
          onclick: render_turbo_stream('form_destroy_row', {row: row}) %>
      </td>
    <% end %>
  <% end %>
<% end %>

app/views/measurements/_form_close.html.erb
<%= turbo_stream.update :new_readouts_form %>
<%= turbo_stream.update :flashes %>

app/views/measurements/_form_destroy_row.html.erb
<%= turbo_stream.remove row %>
<%= turbo_stream.update :flashes %>

app/views/measurements/_form_frame.html.erb
<%= tabular_form_with url: new_measurement_path, html: {id: :new_readouts_form} do %>
  <% if @readouts&.present? %>
    <fieldset>
      <%= tag.legend @closest_ancestor.full_name if @closest_ancestor&.full_name %>
      <table class="items centered">
        <tbody id="readouts">
          <tr id="new_readouts_actions">
            <td></td>
            <td></td>
            <td><div class="actions"><%= button_tag %></div></td>
            <td><div class="actions">
              <%= image_link_to t(:cancel), "close-outline", measurements_path,
                class: 'dangerous', name: :cancel,
                onclick: render_turbo_stream('form_close') %>
            </div></td>
          </tr>
        </tbody>
      </table>
    </fieldset>
  <% end %>
<% end %>

app/views/measurements/index.html.erb
<div class="topside vflex">
  <% if current_user.at_least(:active) %>
    <%= render partial: 'form_frame' %>
    <%# TODO: show hint when no quantities/units defined %>
    <div class="hflex">
      <%= select_tag :id, options_from_collection_for_select(
        @quantities, :id, ->(q){ sanitize('&emsp;'*q.depth + q.name) }
      ), form: :new_readouts_form %>
      <% common_options = {form: :new_readouts_form, formaction: new_measurement_path,
                           formmethod: :get, formnovalidate: true,
                           data: {turbo_stream: true}} %>
      <%= image_button_tag t('.new_quantity'), 'plus-outline', name: :scope,
        **common_options -%>
      <%= image_button_tag t('.new_children'), 'plus-multiple-outline', name: :scope,
        value: :children, **common_options -%>
      <%= image_button_tag t('.new_subtree'), 'plus-multiple-outline', name: :scope,
        value: :subtree, **common_options -%>
    </div>
  <% end %>
</div>

app/views/measurements/new.turbo_stream.erb
<%= turbo_stream.replace :new_readouts_form do %>
  <%= render partial: 'form_frame' %>
<% end if @prev_quantities.empty? %>

<%= turbo_stream.before :new_readouts_actions do %>
  <%= render partial: 'form' %>
<% end %>